/*************************************************************************
Title:    Accelerometer
Author:   Levas
File:     
Software: AVR-GCC 3.3
Hardware: Levo ATMEGA16 testavimo modulis
**************************************************************************/
#define F_CPU 12000000UL
#include <stdlib.h>
#include <avr/io.h>
#include <avr/pgmspace.h>

#include "lcd.c"
#include <util\delay.h>


int getADC(char i)
{
	ADMUX  = i;
	ADMUX |= _BV(REFS0) | _BV(REFS1);
	ADCSRA |=_BV(ADSC);
	loop_until_bit_is_set(ADCSRA, ADIF); //uzsiciklinam kol nebaigs darba ADC.
	return ADCW;
}

int main(void)
{
    char buffer[16];
	int x,y,z;
	char i;
	
	DDRB &=~ (1 << PB3);        /* Pin PB3 input              */
    PORTB |= (1 << PB3);        /* Pin PB3 pull-up enabled    */
	
    
    /* initialize display, cursor off */
    lcd_init(LCD_DISP_ON);
	
	//Apie visus situs bitus geriau pasiskaityti ATMEGA16 datasheete.
	ADCSRA |=_BV(ADEN);
	ADCSRA |=_BV(ADPS0) | _BV(ADPS1) | _BV(ADPS2);

    for (;;) {                           /* loop forever */
			lcd_clrscr();   /* clear display home cursor */
			
			if ( PINB & _BV(PINB3) ) {
			

			x=getADC(0);
			lcd_puts("X:");
			itoa( x, buffer, 10);
			lcd_puts(buffer);

			x=getADC(1);
			lcd_gotoxy(8,0);
			lcd_puts("Y:");
			itoa( x, buffer, 10);
			lcd_puts(buffer);

			x=getADC(2);
			lcd_gotoxy(0,1); 
			lcd_puts("Z:");
			itoa( x, buffer, 10);
			lcd_puts(buffer);
		
			
			} //if bit3
			else
			{
			lcd_puts("Gravity:");
			x=getADC(0)/100;
			y=getADC(1)/100;
			z=getADC(2)/100;
			
			if (x<7 && y<7 && z>7) {lcd_puts("GROUND");}
			if (x<7 && y<7 && z<5) {lcd_puts("OVER");}
			if (x<7 && y<4 && z<7) {lcd_puts("RIGHT");}
			if (x<7 && y>7 && z<7) {lcd_puts("LEFT");}
			if (x>7 && y<7 && z<7) {lcd_puts("BOTTOM");}
			if (x<5 && y<7 && z<7) {lcd_puts("TOP");}
			}
			
			for (i=0; i<10; i++){
				_delay_ms(20); // pauzike.
				}
    }
}
